#include "stdint.h"
#include <sys/platform.h>
#include "time.h"
	#include "defSC573.h"
	#include "cdefSC573.h"

enum MEMTYPE
{
	MEMTYPE_L1S1,
	MEMTYPE_L1S2,
	MEMTYPE_L1S1_CORE2,
	MEMTYPE_L1S2_CORE2,
	MEMTYPE_L2,
	MEMTYPE_L3_DMC0,
	MEMTYPE_L3_DMC1
};

enum EMDMA_DIRECTION
{
	EMDMA_READ,
	EMDMA_WRITE
};

typedef struct
{
	uint32_t uiEMDMAStreamNo;
	uint32_t uiIntMem;
	uint32_t uiExtMem;
	uint32_t uiDirection;
	uint32_t uiBytes;
	float 	 fCoreClockSpeedMHz;
}EMDMA_PARAM_LIST;

//This macro can be used to configure an EMDMA stream by providing the source and destination DMA channel details
#define EMDMA_CONFIG(EMDMA_CHANNEL,EMDMA_CTL,INT_ADDRSTART, INT_MOD, INT_COUNT, EXT_ADDRSTART, EXT_MOD, EXT_COUNT)\
	*pREG_EMDMA##EMDMA_CHANNEL##_INDX0=INT_ADDRSTART;\
	*pREG_EMDMA##EMDMA_CHANNEL##_MOD0=INT_MOD;\
	*pREG_EMDMA##EMDMA_CHANNEL##_CNT0=INT_COUNT;\
	*pREG_EMDMA##EMDMA_CHANNEL##_INDX1=EXT_ADDRSTART;\
	*pREG_EMDMA##EMDMA_CHANNEL##_MOD1=EXT_MOD;\
	*pREG_EMDMA##EMDMA_CHANNEL##_CTL=EMDMA_CTL;

#define WAIT_FOR_EMDMA_OVER(EMDMA_CHANNEL)\
	while((*pREG_EMDMA##EMDMA_CHANNEL##_CTL&BITM_EMDMA_CTL_DMAS0)==0);\
	while((*pREG_EMDMA##EMDMA_CHANNEL##_CTL&BITM_EMDMA_CTL_DMAS0)!=0);\
	while((*pREG_EMDMA##EMDMA_CHANNEL##_CTL&BITM_EMDMA_CTL_DMAS1)!=0);

#define DISABLE_EMDMA(EMDMA_CHANNEL)\
	*pREG_EMDMA##EMDMA_CHANNEL##_CTL=0;

#define MAX_DMA_SIZE_BYTES 16384
#define L2_START_ADDRESS 0x20000000
#define DMC0_START_ADDRESS 0x80000000
#define DMC1_START_ADDRESS 0xC0000000


float EMDMA_Throughput_Measure(EMDMA_PARAM_LIST EMDMAParam);
uint32_t GetMemPointer(uint32_t uiMemType);
uint32_t GetMSIZEConfig(uint32_t uiMSIZE);
